(** File generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_alpha.Environment.
Require TezosOfOCaml.Proto_alpha.Alpha_context.
Require TezosOfOCaml.Proto_alpha.Sc_rollup_arith.

Module PVM.
  Definition boot_sector : Set := Alpha_context.Sc_rollup.PVM.boot_sector.
  
  Module S.
    Record signature : Set := {
      name : string;
      parse_boot_sector : string -> option boot_sector;
      pp_boot_sector : Format.formatter -> boot_sector -> unit;
    }.
  End S.
  Definition S := S.signature.
  
  Definition t : Set := {_ : unit @ S}.
End PVM.

Definition all : list Alpha_context.Sc_rollup.Kind.t :=
  [ Alpha_context.Sc_rollup.Kind.Example_arith ].

Definition kind_of_string (function_parameter : string)
  : option Alpha_context.Sc_rollup.Kind.t :=
  match function_parameter with
  | "arith" => Some Alpha_context.Sc_rollup.Kind.Example_arith
  | _ => None
  end.

Definition example_arith_pvm : {_ : unit @ PVM.S} :=
  existS (A := unit) (fun _ => _) tt
    {|
      PVM.S.name := Sc_rollup_arith.name;
      PVM.S.parse_boot_sector := Sc_rollup_arith.parse_boot_sector;
      PVM.S.pp_boot_sector := Sc_rollup_arith.pp_boot_sector
    |}.

Definition of_kind (function_parameter : Alpha_context.Sc_rollup.Kind.t)
  : {_ : unit @ PVM.S} :=
  let 'Alpha_context.Sc_rollup.Kind.Example_arith := function_parameter in
  example_arith_pvm.

Definition kind_of (M : {_ : unit @ PVM.S}) : Alpha_context.Sc_rollup.Kind.t :=
  let 'existS _ _ M := M in
  match kind_of_string M.(PVM.S.name) with
  | Some k_value => k_value
  | None =>
    Pervasives.failwith
      (Format.sprintf
        (CamlinternalFormatBasics.Format
          (CamlinternalFormatBasics.String_literal "The module named "
            (CamlinternalFormatBasics.String CamlinternalFormatBasics.No_padding
              (CamlinternalFormatBasics.String_literal
                " is not in Sc_rollups.all."
                CamlinternalFormatBasics.End_of_format)))
          "The module named %s is not in Sc_rollups.all.") M.(PVM.S.name))
  end.

Definition from (name : string) : option {_ : unit @ PVM.S} :=
  Option.map of_kind (kind_of_string name).

Definition all_names : list string :=
  List.map
    (fun (k_value : Alpha_context.Sc_rollup.Kind.t) =>
      let 'M := of_kind k_value in
      let 'existS _ _ M := M in
      M.(PVM.S.name)) all.

Definition string_of_kind (k_value : Alpha_context.Sc_rollup.Kind.t) : string :=
  let M := of_kind k_value in
  let 'existS _ _ M := M in
  M.(PVM.S.name).

Definition pp
  (fmt : Format.formatter) (k_value : Alpha_context.Sc_rollup.Kind.t) : unit :=
  Format.fprintf fmt
    (CamlinternalFormatBasics.Format
      (CamlinternalFormatBasics.String CamlinternalFormatBasics.No_padding
        CamlinternalFormatBasics.End_of_format) "%s") (string_of_kind k_value).
